=== debian/changelog ===
gromacs (5.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 3.9.6, no changes required.
  * Update rules to build GPU-accelerated packages, with thanks to
    Steffen Möller.

 -- Nicholas Breen <nbreen@debian.org>  Sun, 05 Oct 2014 10:29:34 -0700

gromacs (5.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Rebase patches involving man pages (moved from share/man to doc/man in
    tarball), drop 20_random123_platforms.patch (incorporated upstream),
    and remove the leading numbers from all patch filenames (a leftover from
    dpatch).
  * man/mdrun_mpi.*: Update .TH line.
  * rules: Set CMAKE_RULE_MESSAGES=OFF to work around blhc false positives
    for "W-compiler-flags-hidden".
  * Move debian/upstream to debian/upstream/metadata.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 06 Sep 2014 11:20:17 -0700

gromacs (5.0-3) unstable; urgency=medium

  * Upload to unstable.

 -- Nicholas Breen <nbreen@debian.org>  Sun, 24 Aug 2014 20:02:24 -0700

gromacs (5.0-2) experimental; urgency=low

  * Add 20_random123_platforms.patch to disable architecture check from
    external Random123 code.
  * Drop discussion of shared libraries from README.Debian for
    gromacs-{mpich,openmpi}.

 -- Nicholas Breen <nbreen@debian.org>  Wed, 02 Jul 2014 20:13:01 -0700

gromacs (5.0-1) experimental; urgency=low

  * New upstream release, experimental upload.
    - g_sigeps / gmx sigeps command line handling no longer crashes on
      invalid input (Closes: #715935).
  * Rebase existing patches.  Add new patches:
    - 31_manpage_hyphenation.patch: Some parts of the man page generation
      get the hyphen/dash separation right, some don't.  A temporary fix
      pending significant overhaul of the man page system.
      <http://redmine.gromacs.org/issues/1437>
    - 32_spelling.patch: Correction of minor spelling errors.
  * man/g_{dos,kinetics,luck}.1: Incorporated upstream, removed.
  * man/gmx.1: Rudimentary man page written and added.
  * man/mdrun_mpi.*.1: Updated with text from upstream gmx-mpich.1.
  * rules: Updates for MPI builds and assorted upstream changes.
  * gromacs-data.lintian-overrides, source/lintian-overrides: Removed.
  * Add Build-Depends on external libboost-dev.
  * Switch away from hardening-wrapper in favor of dpkg-buildflags.
  * Update copyright file.

 -- Nicholas Breen <nbreen@debian.org>  Wed, 02 Jul 2014 17:35:18 -0700
